Angular/Custom form
Loading live demo…from dhtmlx.github.io
Angular
Custom form
Replace the default task editor with a custom Angular lightbox component.
- custom-form.ts
- custom-form.html
- custom-form.css
- shared/custom-form.ts
src/app/samples/custom-form/custom-form.ts View on GitHub
import { Component, ViewEncapsulation } from '@angular/core';
import { createBasicDemoData } from '../../shared/demo-data';
import { CustomLightboxConfig, DhxGanttComponent } from '@dhtmlx/trial-angular-gantt';
import { CustomLightboxComponent } from '../../shared/custom-form/custom-form';
@Component({
selector: 'custom-form',
standalone: true,
imports: [DhxGanttComponent],
templateUrl: './custom-form.html',
styleUrl: './custom-form.css',
encapsulation: ViewEncapsulation.None
})
export class CustomFormComponent {
private readonly initial = createBasicDemoData();
tasks = this.initial.tasks;
links = this.initial.links;
ganttLightboxConfig: CustomLightboxConfig = {
component: CustomLightboxComponent,
onSave: (data) => console.log('Saved:', data),
onCancel: () => console.log('Cancelled'),
onDelete: (id) => console.log('Deleted:', id)
};
config = {
columns: [
{ name: "text", label: "Task name", tree: true, width: "*" },
{ name: "start_date", label: "Start", align: "center" },
{ name: "duration", label: "Duration", align: "center" },
{ name: "add", width: 44 },
],
date_format: "%Y-%m-%d %H:%i",
};
}
src/app/samples/custom-form/custom-form.html View on GitHub
<div class="card">
<div class="gantt-host">
<dhx-gantt style="height:600px" [tasks]="tasks" [links]="links" [config]="config"
[customLightbox]="ganttLightboxConfig">
</dhx-gantt>
</div>
</div>
src/app/samples/custom-form/custom-form.css View on GitHub
@import "@dhtmlx/trial-angular-gantt/dist/angular-gantt.css";
.dhx-gantt-root {
height: 100%;
width: 100%;
}
src/app/shared/custom-form/custom-form.ts View on GitHub
import { Component, Input } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
export interface LightboxData {
id: string | number;
task: any;
}
@Component({
selector: 'custom-lightbox',
standalone: true,
imports: [CommonModule, FormsModule],
template: `
<div class="lightbox-modal">
<div class="lightbox-header">
<h3>{{ isNewTask ? 'New Task' : 'Edit Task' }}</h3>
<button class="close-btn" (click)="onCancelClick()" title="Close">
×
</button>
</div>
<div class="lightbox-body">
<div class="form-group">
<label>Task Name:</label>
<input
[(ngModel)]="localTask.text"
class="form-input"
placeholder="Enter task name"
(keyup.enter)="onSaveClick()"
/>
</div>
</div>
<div class="lightbox-footer">
<button class="btn btn-danger" (click)="onDeleteClick()" [disabled]="isNewTask">
Delete
</button>
<button class="btn btn-secondary" (click)="onCancelClick()">
Cancel
</button>
<button class="btn btn-primary" (click)="onSaveClick()">
Save
</button>
</div>
</div>
`,
styles: [` .lightbox-modal {
position: fixed;
top: 50%;
left: 50%;
transform: translate(-50%, -50%);
z-index: 1000;
max-width: 500px;
background: #f8f9fa;
width: 100%;
max-height: 90vh;
overflow: hidden;
}
.lightbox-header {
display: flex;
justify-content: space-between;
align-items: center;
padding: 20px 24px 16px;
border-bottom: 1px solid #e0e0e0;
background: #f8f9fa;
}
.lightbox-header h3 {
margin: 0;
font-size: 20px;
font-weight: 600;
color: #333;
}
.close-btn {
background: none;
border: none;
font-size: 24px;
cursor: pointer;
color: #666;
padding: 0;
width: 32px;
height: 32px;
display: flex;
align-items: center;
justify-content: center;
border-radius: 4px;
}
.close-btn:hover {
background: #e0e0e0;
color: #333;
}
.lightbox-body {
padding: 24px;
max-height: 400px;
overflow-y: auto;
}
.form-group {
margin-bottom: 20px;
}
.form-group label {
display: block;
margin-bottom: 6px;
font-weight: 500;
color: #555;
font-size: 14px;
}
.form-input {
width: 100%;
padding: 10px 12px;
border: 1px solid #ddd;
border-radius: 6px;
font-size: 14px;
transition: border-color 0.2s;
box-sizing: border-box;
}
.form-input:focus {
outline: none;
border-color: #007bff;
box-shadow: 0 0 0 3px rgba(0,123,255,0.1);
}
.form-row {
display: grid;
grid-template-columns: 1fr 1fr;
gap: 16px;
}
.form-range {
width: 100%;
height: 6px;
margin-top: 8px;
}
.lightbox-footer {
padding: 16px 24px 24px;
border-top: 1px solid #e0e0e0;
background: #f8f9fa;
display: flex;
gap: 12px;
justify-content: flex-end;
}
.btn {
padding: 10px 20px;
border: none;
border-radius: 6px;
font-size: 14px;
font-weight: 500;
cursor: pointer;
transition: all 0.2s;
min-width: 80px;
}
.btn:disabled {
opacity: 0.5;
cursor: not-allowed;
}
.btn-primary {
background: #007bff;
color: white;
}
.btn-primary:hover:not(:disabled) {
background: #0056b3;
transform: translateY(-1px);
}
.btn-secondary {
background: #6c757d;
color: white;
}
.btn-secondary:hover:not(:disabled) {
background: #545b62;
}
.btn-danger {
background: #dc3545;
color: white;
}`]
})
export class CustomLightboxComponent {
@Input() data!: LightboxData;
@Input() onSave!: (task: any) => void;
@Input() onCancel!: () => void;
@Input() onDelete!: () => void;
localTask: any = {};
ngOnInit() {
if (this.data?.task) {
this.localTask = { ...this.data.task };
}
}
get isNewTask(): boolean {
return Boolean(this.localTask?.$new);
}
onSaveClick() {
this.onSave(this.localTask);
}
onCancelClick() {
this.onCancel();
}
onDeleteClick() {
this.onDelete();
}
}

React/Custom form
Loading live demo…from dhtmlx.github.io
React
Custom form
Replace the default task editor with a draggable Material UI modal form.
- Demo.tsx
- EditorModal.tsx
src/examples/custom-form/Demo.tsx View on GitHub
import { useEffect, useRef } from 'react';
import ReactGantt from "@dhtmlx/trial-react-gantt";
import "@dhtmlx/trial-react-gantt/dist/react-gantt.css";
import CustomLightbox from "./EditorModal";
export default function BasicInitDemo() {
const ganttRef = useRef(null);
useEffect(() => {
document.title = "DHTMLX React Gantt | Custom Form";
}, []);
const tasks = [
{ id: 1, text: "Office itinerancy", type: "project", progress: 0.4, open: true, start_date: "02-04-2025 00:00", duration: 17, parent: 0 },
{ id: 2, text: "Office facing", type: "project", start_date: "02-04-2025 00:00", duration: 5, progress: 0.6, parent: 1, open: true },
{ id: 5, text: "Interior office", type: "task", start_date: "02-04-2025 00:00", duration: 3, parent: 2, progress: 0.6, open: true },
{ id: 6, text: "Air conditioners check", type: "task", start_date: "05-04-2025 00:00", duration: 2, parent: 2, progress: 0.29, open: true },
{ id: 3, text: "Furniture installation", type: "project", start_date: "08-04-2025 00:00", duration: 2, parent: 1, progress: 0.6, open: false },
{ id: 7, text: "Workplaces preparation", type: "task", start_date: "08-04-2025 00:00", duration: 2, parent: 3, progress: 0.6, open: true }
];
const links = [
{ id: 1, source: "2", target: "3", type: "0" },
];
useEffect(() => {
//const gantt = ganttRef.current?.instance;
}, []);
return (
<div className="demo-container">
<title>DHTMLX React Gantt | Custom Edit Form</title>
<ReactGantt
ref={ganttRef}
tasks={tasks}
links={links}
customLightbox={<CustomLightbox />}
/>
</div>
);
}
src/examples/custom-form/EditorModal.tsx View on GitHub
import React, { useState } from 'react';
import Button from "@mui/material/Button";
import TextField from '@mui/material/TextField';
import Dialog from '@mui/material/Dialog';
import DialogActions from '@mui/material/DialogActions';
import DialogContent from '@mui/material/DialogContent';
import DialogContentText from '@mui/material/DialogContentText';
import DialogTitle from '@mui/material/DialogTitle';
import Paper from '@mui/material/Paper';
import Draggable from 'react-draggable';
export interface CustomLightboxProps {
data?: any;
onSave?: (task: any) => void;
onCancel?: () => void;
onDelete?: () => void;
}
const CustomLightbox: React.FC<CustomLightboxProps> = ({
data,
onSave,
onCancel,
onDelete
}) => {
let updatedTaskText = data.text || "";
const handleSaveClick = () => {
if(onSave)
onSave({ ...data, text: updatedTaskText });
};
function PaperComponent(props: any) {
const nodeRef = React.useRef(null);
return (
<Draggable
nodeRef={nodeRef}
handle="#draggable-dialog-title"
cancel={'[class*="MuiDialogContent-root"], input,textarea'}
>
<Paper {...props} ref={nodeRef}/>
</Draggable>
);
}
function TextComponent() {
const [description, setDescription] = useState<string>(data.text || '');
return (
<TextField
id="task_text"
hiddenLabel
multiline
value={description}
autoFocus
onChange={(e) => {
updatedTaskText = e.target.value;
setDescription(e.target.value)
}}
sx={{ width: '100%', padding: '8px', marginTop: '10px' }}
/>
)
}
return (
<Dialog
open={true}
PaperComponent={PaperComponent}
aria-labelledby="draggable-dialog-title"
className="lightbox"
onClose={onCancel}
>
<DialogTitle style={{ cursor: 'move' }} id="draggable-dialog-title">
Edit Task
</DialogTitle>
<DialogContent>
<DialogContentText id="alert-dialog-description">
Description
</DialogContentText>
<TextComponent />
<DialogActions className='buttons'>
<Button variant="contained" onClick={handleSaveClick}>Save</Button>
<Button variant="contained" onClick={onCancel}>Cancel</Button>
<Button variant="contained" onClick={onDelete}>Delete</Button>
</DialogActions>
</DialogContent>
</Dialog>
);
};
export default CustomLightbox;

Vue/Custom form
Loading live demo…from dhtmlx.github.io
Vue
Custom form
Replace the default task editor with a custom Vue lightbox component using batched task updates.
- Demo.vue
- CustomLightbox.vue
- shared/projectData.ts
- shared/useDemoBatchState.ts
src/examples/custom-form/Demo.vue View on GitHub
<script setup lang="ts">
import { VueGantt } from "@dhtmlx/trial-vue-gantt";
import "@dhtmlx/trial-vue-gantt/dist/vue-gantt.css";
import { createProjectData } from "../shared/projectData";
import { useDemoBatchState } from "../shared/useDemoBatchState";
import CustomLightbox from "./CustomLightbox.vue";
const { tasks, links, data } = useDemoBatchState(createProjectData());
</script>
<template>
<section class="demo-panel" data-cy="custom-form-demo">
<VueGantt
class="demo-gantt"
:tasks="tasks"
:links="links"
:customLightbox="CustomLightbox"
:data="data"
/>
</section>
</template>
src/examples/custom-form/CustomLightbox.vue View on GitHub
<script setup lang="ts">
import { ref, watch } from "vue";
interface CustomLightboxProps {
data?: any;
onSave?: (updatedTask: any) => void;
onCancel?: () => void;
onDelete?: () => void;
}
const props = defineProps<CustomLightboxProps>();
const text = ref("");
watch(
() => props.data,
nextValue => {
text.value = String(nextValue?.text ?? "");
},
{ immediate: true }
);
const save = () => {
props.onSave?.({ ...props.data, text: text.value });
};
</script>
<template>
<div class="lightbox-backdrop" data-cy="custom-lightbox">
<div class="lightbox-panel" role="dialog" aria-modal="true">
<h3>Edit Task</h3>
<label class="field">
<span>Task Text</span>
<input data-cy="custom-lightbox-text" type="text" v-model="text" />
</label>
<div class="actions">
<button data-cy="custom-lightbox-save" type="button" @click="save">Save</button>
<button data-cy="custom-lightbox-cancel" type="button" @click="props.onCancel?.()">Cancel</button>
<button data-cy="custom-lightbox-delete" type="button" @click="props.onDelete?.()">Delete</button>
</div>
</div>
</div>
</template>
<style scoped>
.lightbox-backdrop {
position: fixed;
inset: 0;
display: flex;
align-items: center;
justify-content: center;
background: rgba(16, 27, 38, 0.45);
z-index: 1000;
}
.lightbox-panel {
width: min(420px, calc(100vw - 24px));
background: #fff;
border: 1px solid #cfd8e2;
border-radius: 8px;
padding: 14px;
}
h3 {
margin: 0 0 12px;
}
.field {
display: block;
}
.field span {
display: inline-block;
font-size: 12px;
margin-bottom: 4px;
color: #455a6f;
}
.field input {
width: 100%;
border: 1px solid #cfd8e2;
padding: 8px;
font-size: 14px;
}
.actions {
margin-top: 12px;
display: flex;
gap: 8px;
justify-content: flex-end;
}
.actions button {
border: 1px solid #cfd8e2;
background: #fff;
padding: 6px 10px;
cursor: pointer;
}
.actions button:hover {
border-color: #91abd0;
}
</style>
src/examples/shared/projectData.ts View on GitHub
import type { Link, Task } from "@dhtmlx/trial-vue-gantt";
const baseTasks: Task[] = [
{ id: 1, text: "Office itinerancy", type: "project", start_date: new Date(2026, 6, 2), duration: 17, progress: 0.4, parent: 0, open: true },
{ id: 2, text: "Office facing", type: "project", start_date: new Date(2026, 6, 2), duration: 8, progress: 0.6, parent: 1, open: true },
{ id: 3, text: "Furniture installation", type: "project", start_date: new Date(2026, 6, 11), duration: 8, progress: 0.6, parent: 1, open: true },
{ id: 4, text: "The employee relocation", type: "project", start_date: new Date(2026, 6, 13), duration: 5, progress: 0.5, parent: 1, priority: 3, open: true },
{ id: 5, text: "Interior office", type: "task", start_date: new Date(2026, 6, 3), duration: 7, progress: 0.6, parent: 2, priority: 1 },
{ id: 6, text: "Air conditioners check", type: "task", start_date: new Date(2026, 6, 3), duration: 7, progress: 0.6, parent: 2, priority: 2 },
{ id: 7, text: "Workplaces preparation", type: "task", start_date: new Date(2026, 6, 12), duration: 8, progress: 0.6, parent: 3 },
{ id: 8, text: "Preparing workplaces", type: "task", start_date: new Date(2026, 6, 14), duration: 5, progress: 0.5, parent: 4, priority: 1 },
{ id: 9, text: "Workplaces importation", type: "task", start_date: new Date(2026, 6, 21), duration: 4, progress: 0.5, parent: 4 },
{ id: 10, text: "Workplaces exportation", type: "task", start_date: new Date(2026, 6, 27), duration: 3, progress: 0.5, parent: 4, priority: 2 },
{ id: 11, text: "Product launch", type: "project", start_date: new Date(2026, 6, 2), duration: 13, progress: 0.6, parent: 0, open: true },
{ id: 12, text: "Perform Initial testing", type: "task", start_date: new Date(2026, 6, 3), duration: 5, progress: 1, parent: 11 },
{ id: 13, text: "Development", type: "project", start_date: new Date(2026, 6, 3), duration: 11, progress: 0.5, parent: 11, open: true },
{ id: 14, text: "Analysis", type: "task", start_date: new Date(2026, 6, 3), duration: 6, progress: 0.8, parent: 11 },
{ id: 15, text: "Design", type: "project", start_date: new Date(2026, 6, 3), duration: 5, progress: 0.2, parent: 11, open: true },
{ id: 16, text: "Documentation creation", type: "task", start_date: new Date(2026, 6, 3), duration: 7, progress: 0, parent: 11, priority: 1 },
{ id: 17, text: "Develop System", type: "task", start_date: new Date(2026, 6, 3), duration: 2, progress: 1, parent: 13, priority: 2 },
{ id: 25, text: "Beta Release", type: "milestone", start_date: new Date(2026, 6, 6), duration: 0, progress: 0, parent: 13 },
{ id: 18, text: "Integrate System", type: "task", start_date: new Date(2026, 6, 10), duration: 2, progress: 0.8, parent: 13, priority: 3 },
{ id: 19, text: "Test", type: "task", start_date: new Date(2026, 6, 13), duration: 4, progress: 0.2, parent: 13 },
{ id: 20, text: "Marketing", type: "task", start_date: new Date(2026, 6, 13), duration: 4, progress: 0, parent: 13, priority: 1 },
{ id: 21, text: "Design database", type: "task", start_date: new Date(2026, 6, 3), duration: 4, progress: 0.5, parent: 15 },
{ id: 22, text: "Software design", type: "task", start_date: new Date(2026, 6, 3), duration: 4, progress: 0.1, parent: 15, priority: 1 },
{ id: 23, text: "Interface setup", type: "task", start_date: new Date(2026, 6, 3), duration: 5, progress: 0, parent: 15, priority: 1 },
{ id: 24, text: "Release v1.0", type: "milestone", start_date: new Date(2026, 6, 18), duration: 0, progress: 0, parent: 11 }
];
const baseLinks: Link[] = [
{ id: 2, source: 2, target: 3, type: "0" },
{ id: 3, source: 3, target: 4, type: "0" },
{ id: 7, source: 8, target: 9, type: "0" },
{ id: 8, source: 9, target: 10, type: "0" },
{ id: 16, source: 17, target: 25, type: "0" },
{ id: 17, source: 18, target: 19, type: "0" },
{ id: 18, source: 19, target: 20, type: "0" },
{ id: 22, source: 13, target: 24, type: "0" },
{ id: 23, source: 25, target: 18, type: "0" }
];
const cloneDate = (value: Date | undefined): Date | undefined => {
if (value instanceof Date) {
return new Date(value.getTime());
}
return value;
};
const cloneTask = (task: Task): Task => {
const next: Task = { ...task };
next.start_date = cloneDate(task.start_date);
next.end_date = cloneDate(task.end_date);
return next;
};
const cloneLink = (link: Link): Link => ({ ...link });
export function createProjectData() {
return {
tasks: baseTasks.map(cloneTask),
links: baseLinks.map(cloneLink)
};
}
src/examples/shared/useDemoBatchState.ts View on GitHub
import { ref } from "vue";
import type { BatchChanges, Link, Task } from "@dhtmlx/trial-vue-gantt";
import { applyBatchChanges } from "./applyBatchChanges";
export interface DemoDataSet {
tasks: Task[];
links: Link[];
}
export function createBatchSaveData(applyBatch: (changes: BatchChanges) => void) {
return {
batchSave: applyBatch
};
}
export function useDemoBatchState(initialData: DemoDataSet) {
const tasks = ref<Task[]>(initialData.tasks);
const links = ref<Link[]>(initialData.links);
const applyBatch = (changes: BatchChanges) => {
const next = applyBatchChanges(tasks.value, links.value, changes);
tasks.value = next.tasks;
links.value = next.links;
};
return {
tasks,
links,
applyBatch,
data: createBatchSaveData(applyBatch)
};
}